<?php

/*********************************************************************

 エントリータグランキング表示プラグイン (2014/06/10)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/


//外部ファイル読み込み
require_once FREO_MAIN_DIR . 'freo/internals/security_entry.php';
require_once FREO_MAIN_DIR . 'freo/internals/filter_entry.php';

/* メイン処理 */
function freo_display_entry_tagranking()
{
	global $freo;

	$tags = array();

	if ($freo->user['id'] or $freo->user['groups'] or isset($_SESSION['security']['entry']) or isset($_SESSION['filter'])) {
		//検索条件設定
		$condition = null;

		//制限されたエントリーを一覧に表示しない
		if (!$freo->config['view']['restricted_display'] and ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author')) {
			$entry_filters = freo_filter_entry('user', array_keys($freo->refer['entries']));
			$entry_filters = array_keys($entry_filters, true);
			$entry_filters = array_map('intval', $entry_filters);
			if (!empty($entry_filters)) {
				$condition .= ' AND id NOT IN(' . implode(',', $entry_filters) . ')';
			}

			$entry_securities = freo_security_entry('user', array_keys($freo->refer['entries']));
			$entry_securities = array_keys($entry_securities, true);
			$entry_securities = array_map('intval', $entry_securities);
			if (!empty($entry_securities)) {
				$condition .= ' AND id NOT IN(' . implode(',', $entry_securities) . ')';
			}
		}

		//エントリータグ取得
		$stmt = $freo->pdo->prepare('SELECT tag FROM ' . FREO_DATABASE_PREFIX . 'entries WHERE approved = \'yes\' AND (status = \'publish\' OR (status = \'future\' AND datetime <= :now1)) AND display = \'publish\' AND tag IS NOT NULL AND (close IS NULL OR close >= :now2) ' . $condition);
		$stmt->bindValue(':now1', date('Y-m-d H:i:s'));
		$stmt->bindValue(':now2', date('Y-m-d H:i:s'));
		$flag = $stmt->execute();
		if (!$flag) {
			freo_error($stmt->errorInfo());
		}

		while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
			foreach (explode(',', $data['tag']) as $tag) {
				if ($tag == '') {
					continue;
				}

				if (isset($tags[$tag])) {
					$tags[$tag]++;
				} else {
					$tags[$tag] = 1;
				}
			}
		}

		arsort($tags, SORT_NUMERIC);
	} else {
		//エントリータグ情報取得
		if ($fp = fopen(FREO_FILE_DIR . 'plugins/entry_tagranking.log', 'r')) {
			while ($line = fgets($fp)) {
				list($tag, $count) = explode(',', trim($line));

				$tags[$tag] = $count;
			}
			fclose($fp);
		} else {
			freo_error('エントリータグ情報保存ファイル ' . FREO_FILE_DIR . 'plugins/entry_tagranking.log を読み込めません。');
		}
		arsort($tags, SORT_NUMERIC);
	}

	//タグクラウド取得
	$tagrankings = array();

	$i = 0;
	$limit = $freo->config['plugin']['entry_tagranking']['limit'];

	foreach($tags as $tag => $count) {
	    if($i >= $limit){
			break;
		}else{
			$tagrankings[] = array(
				'tag'   => $tag,
				'count' => $count
			);
			$i++;
		}
	}
	//データ割当
	$freo->smarty->assign(array(
		'plugin_entry_tagrankings' => $tagrankings
	));

	return;
}

?>
